// AttachDownloadList.cpp :  Դϴ.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "AttachDownloadList.h"

// CAttachDownloadList

IMPLEMENT_DYNAMIC(CAttachDownloadList, CListCtrl)

CAttachDownloadList::CAttachDownloadList()
{
	m_pImgBG = NULL;
	m_pImgFile = NULL;
	m_pImgProgressBG = NULL;
	m_pImgProgressFG = NULL;

	m_crBG = DEF_ATTACH_LIST_BG_COLOR;
	m_crItemBG = DEF_ATTACH_LIST_ITEM_BG_COLOR;
	m_crItemSelBG = DEF_ATTACH_LIST_ITEMSEL_BG_COLOR;
	m_crOutline = DEF_ATTACH_LIST_LINE_COLOR;

    _tcsncpy(m_wszFontName, DEF_ATTACH_LIST_FONT_NAME, _countof(m_wszFontName) - 1);
	//_tcscpy_s(m_wszFontName, DEF_ATTACH_LIST_FONT_NAME);
	m_nFontHeight = DEF_ATTACH_LIST_FONT_HEIGHT;
	m_fontStyle = DEF_ATTACH_LIST_FONT_STYLE;
	m_crText = DEF_ATTACH_LIST_FONT_COLOR;
}

CAttachDownloadList::~CAttachDownloadList()
{
    //Release in OnDestory
    ASSERT(NULL == m_pImgBG);
    ASSERT(NULL == m_pImgFile);
    ASSERT(NULL == m_pImgProgressBG);
}//lint !e1540

void CAttachDownloadList::SetImgBGPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgBG = new Image(strImgPath);
}

void CAttachDownloadList::SetImgProgressPath(CString strFileNameFG, CString strFileNameBG)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileNameFG.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameFG);

	m_pImgProgressFG = new Image(strImgPath);

	if (strFileNameBG.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameBG);

	m_pImgProgressBG = new Image(strImgPath);
}

void CAttachDownloadList::SetImgFilePath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgFile = new Image(strImgPath);
}

void CAttachDownloadList::SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText)
{
    _tcsncpy(m_wszFontName, wszFontName, _countof(m_wszFontName) - 1);
	//_tcscpy_s(m_wszFontName, wszFontName);
	m_nFontHeight = nFontHeight;
	m_fontStyle = style;

	m_crText = crText;
}

void CAttachDownloadList::ClearAttachItem()
{
	CAttachDownloadList::_attach_list_item* pAttachItem = NULL;
	int nCnt = GetItemCount();
	for (int i = 0; i < nCnt; i++)
	{
		pAttachItem = (CAttachDownloadList::_attach_list_item*)GetItemData(i);
		if (!pAttachItem)
			continue;

		delete pAttachItem;
	}
	
	DeleteAllItems();
}

CAttachDownloadList::_attach_list_item* CAttachDownloadList::AllocAttachItem(CString strName, ULONGLONG dwSize, int nStatus)
{
	CAttachDownloadList::_attach_list_item* pAttachItem = new CAttachDownloadList::_attach_list_item;
	if (!pAttachItem)
		return NULL;

	pAttachItem->strName = strName;
	pAttachItem->dwTotalSize = dwSize;
	pAttachItem->dwCurDownloadSize = 0;
	pAttachItem->eStatus = (CAttachDownloadList::_attach_status)nStatus;

	return pAttachItem;
}

void CAttachDownloadList::AddAttachItem(CString strName, ULONGLONG dwSize, int nStatus)
{
	CAttachDownloadList::_attach_list_item* pAttachItem = NULL;
	pAttachItem = AllocAttachItem(strName, dwSize, nStatus);
	if (!pAttachItem)
		return;

	int nCntItem = GetItemCount();
	
	int nItem = nCntItem;
	InsertItem(nItem, strName);

	ULONGLONG dwRemainSize = dwSize % 1024;
	ULONGLONG dwFileSize = dwSize / 1024;
	if (dwRemainSize > 0)
	dwFileSize += 1;

	CString strSize = _T("");
	strSize.Format(_T("%d"), (INT)dwFileSize);
	strSize = InsertCharToString(strSize, 3, _T(','));
	strSize += _T("KB");

	pAttachItem->strSize = strSize;

	SetItemText(nItem, 1, strSize);
	SetItemText(nItem, 2, _T(""));

	SetItemData(nItem, (DWORD)pAttachItem);
}

void CAttachDownloadList::UpdateAttachItemSize(int nItem, ULONGLONG dwSize)
{
	CAttachDownloadList::_attach_list_item* pAttachItem = (CAttachDownloadList::_attach_list_item*)GetItemData(nItem);
	if (!pAttachItem)
		return;

	pAttachItem->dwCurDownloadSize = dwSize;

	UpdateSubItem(nItem, 2);
}

void CAttachDownloadList::UpdateAttachItemStatus(int nItem, int nStatus)
{
	CAttachDownloadList::_attach_list_item* pAttachItem = (CAttachDownloadList::_attach_list_item*)GetItemData(nItem);
	if (!pAttachItem)
		return;

	pAttachItem->eStatus = (CAttachDownloadList::_attach_status)nStatus;

	UpdateSubItem(nItem, 2);
}

void CAttachDownloadList::UpdateSubItem(int nItem, int nSubItem)
{
	CRect rect(0, 0, 0, 0);
	if (nSubItem == -1)
	{
		GetItemRect(nItem, &rect, LVIR_BOUNDS);
	}
	else
	{
		GetSubItemRect(nItem, nSubItem, LVIR_BOUNDS, rect);
	}

	RedrawWindow(&rect, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

BEGIN_MESSAGE_MAP(CAttachDownloadList, CListCtrl)
	ON_NOTIFY_REFLECT(NM_CUSTOMDRAW, OnCustomDraw)
	ON_WM_DESTROY()
END_MESSAGE_MAP()

// CAttachDownloadList ޽ óԴϴ.

void CAttachDownloadList::OnDestroy()
{
	if (m_pImgBG)
	{
		delete m_pImgBG;
		m_pImgBG = NULL;
	}

	if (m_pImgFile)
	{
		delete m_pImgFile;
		m_pImgFile = NULL;
	}

	if (m_pImgProgressBG)
	{
		delete m_pImgProgressBG;
		m_pImgProgressBG = NULL;
	}
	if (m_pImgProgressFG)
	{
		delete m_pImgProgressFG;
		m_pImgProgressFG = NULL;
	}

	ClearAttachItem();

	CListCtrl::OnDestroy();
}

void CAttachDownloadList::OnCustomDraw(NMHDR* pNMHDR, LRESULT* pResult)
{
	NMLVCUSTOMDRAW* pLVCD = reinterpret_cast<NMLVCUSTOMDRAW*>(pNMHDR);

	int nItem = static_cast<int>(pLVCD->nmcd.dwItemSpec);
	int nSubItem = pLVCD->iSubItem;

	CString strItem = _T(""), strMsg = _T("");

	*pResult = CDRF_DODEFAULT;

	if (pLVCD->nmcd.dwDrawStage == CDDS_PREPAINT)
	{
		*pResult = CDRF_NOTIFYITEMDRAW;
	}
	else if (pLVCD->nmcd.dwDrawStage == CDDS_ITEMPREPAINT)
	{
		*pResult = CDRF_NOTIFYSUBITEMDRAW;
	}
	else if (pLVCD->nmcd.dwDrawStage == (CDDS_ITEMPREPAINT | CDDS_SUBITEM))
	{
		*pResult = CDRF_DODEFAULT;

		CAttachDownloadList::_attach_list_item* pAttachItem = (CAttachDownloadList::_attach_list_item*)GetItemData(nItem);
		if (!pAttachItem)
			return;

        CRect rtItem(0, 0, 0, 0);
		GetSubItemRect(nItem, nSubItem, LVIR_BOUNDS, rtItem);

		CDC* pDC = CDC::FromHandle(pLVCD->nmcd.hdc);
		if (!pDC)
			return;

		int psWidth = rtItem.Width();
		int psHeight = rtItem.Height();

		int nPX = rtItem.left;
		int nPY = rtItem.top;

		CRect rtPS(0, 0, psWidth, psHeight);

		HDC	hdcMemory = CreateCompatibleDC(pDC->m_hDC);

		if (hdcMemory == NULL)
			return;

		HBITMAP hbmpMem = CreateCompatibleBitmap(pDC->m_hDC, psWidth, psHeight);

		HGDIOBJ hbmpOld = ::SelectObject(hdcMemory, hbmpMem);

		if (hbmpMem == NULL)
			return;

		Graphics graph(hdcMemory);

		graph.SetSmoothingMode(SmoothingModeAntiAlias);
		graph.SetInterpolationMode(InterpolationModeHighQualityBicubic);
		graph.SetPageUnit(UnitPixel);

		SolidBrush brush(m_crItemBG);
		Pen pen(m_crItemBG, 1);
		graph.DrawRectangle(&pen, 0, 0, psWidth, psHeight);
		graph.FillRectangle(&brush, 0, 0, psWidth, psHeight);		

		int nImgDX = 0, nImgDY = 0, nImgWidth = 0, nImgHeight = 0;
		
		switch (nSubItem)
		{
		case 0:
			{
				if (m_pImgFile)
				{
					nImgWidth = m_pImgFile->GetWidth();
					nImgHeight = m_pImgFile->GetHeight();

					nImgDX += DEF_LIST_NAME_LEFT_POS_X;
					nImgDY += ((rtItem.Height() - nImgHeight) / 2);

					graph.DrawImage(m_pImgFile, nImgDX, nImgDY, nImgWidth, nImgHeight);
				}

				CRect rtName(0, 0, 0, 0);
				rtName.left = nImgDX + DEF_LIST_NAME_LEFT_POS_X + nImgWidth;
				if (!(pAttachItem->strName.IsEmpty()))
				{					
					REAL nFontHeight = m_nFontHeight;
					CRect rtBound(0, 0, 500, 500);
					RecalcTextRect(this, pAttachItem->strName, m_wszFontName, nFontHeight, m_fontStyle, rtBound, pAttachItem->szName);

					rtName.top = ((psHeight - pAttachItem->szName.cy) / 2);
					rtName.right = rtName.left + pAttachItem->szName.cx + 5;
					rtName.bottom = rtName.top + pAttachItem->szName.cy;

					DrawTextToDest2(&graph,
									pAttachItem->strName, &rtPS, &rtName,
									m_wszFontName, m_nFontHeight,
									StringAlignmentNear,
									m_fontStyle,
									m_crText);
				}
				*pResult = CDRF_SKIPDEFAULT;
			}
			break;
		case 1:
			{
				CRect rtSize(0, 0, 0, 0);
				if (!(pAttachItem->strSize.IsEmpty()))
				{
					rtSize.right = rtItem.Width();
					rtSize.top = ((psHeight - pAttachItem->szName.cy) / 2);
					rtSize.bottom = rtSize.top + pAttachItem->szName.cy;

					DrawTextToDest2(&graph,
									pAttachItem->strSize, &rtPS, &rtSize,
									m_wszFontName, m_nFontHeight,
									StringAlignmentFar,
									m_fontStyle,
									m_crText);
				}
				*pResult = CDRF_SKIPDEFAULT;
			}
			break;
		case 2:
			{
				if (pAttachItem->eStatus != EATTACH_COMPLETE)
				{
					CRect rtProgressBG(0, 0, 0, 0);
					if (m_pImgProgressBG)
					{
						nImgWidth = m_pImgProgressBG->GetWidth();
						nImgHeight = m_pImgProgressBG->GetHeight();

						rtProgressBG.right = rtItem.Width();
						rtProgressBG.top = ((psHeight - nImgHeight) / 2);
						rtProgressBG.bottom = rtProgressBG.top + nImgHeight;

						graph.DrawImage(m_pImgProgressBG, rtProgressBG.left, rtProgressBG.top, rtProgressBG.Width(), rtProgressBG.Height());

						CRect rtProgressFG(0, 0, 0, 0);
						if (m_pImgProgressFG)
						{
							nImgHeight = m_pImgProgressFG->GetHeight();

							double fPctProgress = 0;
							fPctProgress = ((double)(pAttachItem->dwCurDownloadSize) * 100) / (double)(pAttachItem->dwTotalSize);

							rtProgressFG.right = (LONG)(rtProgressFG.left + (rtItem.Width() * fPctProgress / 100));
							rtProgressFG.top = rtProgressBG.top;
							rtProgressFG.bottom = rtProgressBG.bottom;

							graph.DrawImage(m_pImgProgressFG, rtProgressFG.left, rtProgressFG.top, rtProgressFG.Width(), rtProgressFG.Height());
						}
					}
				}
				else
				{
					CRect rtProgress(0, 0, 0, 0);
					rtProgress.right = rtItem.Width();
					rtProgress.top = ((psHeight - pAttachItem->szName.cy) / 2);
					rtProgress.bottom = rtProgress.top + pAttachItem->szName.cy;

					DrawTextToDest2(&graph,
									LoadStringFromResource(IDS_STRING538), &rtPS, &rtProgress,
									m_wszFontName, m_nFontHeight,
									StringAlignmentCenter,
									m_fontStyle,
									m_crText);
				}
				*pResult = CDRF_SKIPDEFAULT;
			}
			break;
		}

		BitBlt(pDC->m_hDC, nPX, nPY, psWidth, psHeight, hdcMemory, 0, 0, SRCCOPY);

		::SelectObject(hdcMemory, hbmpOld);
		::DeleteObject(hbmpMem);

		::DeleteDC(hdcMemory);
	}
}

void CAttachDownloadList::UpdateAttachItemFilename( int nItem, LPCTSTR strRename )
{
	CAttachDownloadList::_attach_list_item* pAttachItem = (CAttachDownloadList::_attach_list_item*)GetItemData(nItem);
	if (!pAttachItem)
		return;

	pAttachItem->strName = strRename;

	UpdateSubItem(nItem, 0);
}
